/*
   Projet de simulation d'inondation.
   
   Version C++ utilisant QT et OpenGL.
   
   10 Avril 2004

   (C) Eric Beaudry & Universit de Sherbrooke 2004.
*/

#if !defined(__MAIN_H__)
#define __MAIN_H__

#include <qapplication.h>
#include <qmainwindow.h>
#include "SimInondation.h"
#include "terrain.h"
#include "controlbase.h"


class SimInondMainWindow : public QMainWindow {

 Q_OBJECT

  public:
    SimInondMainWindow();

  public slots:
     void                  slotFileQuit();
     void                  slotLoadMnt();
     
     void                  slotTestSin();
     void                  slotTestRandom();
        
  protected:
     SimInondWidget*       terrainView;
     Terrain*              terrain;
     ModeleSimple*         modelsimple;
     ControlBase*          controlWidget;
     int                   numeroIteration;
     
     void                  createMenus();
     void                  timerEvent( QTimerEvent * );
};

#endif
