/*
   Projet de simulation d'inondation.
   
   Version C++ utilisant QT et OpenGL.
   
   10 Avril 2004

   (C) Eric Beaudry & Universit de Sherbrooke 2004.
*/

#if !defined(__TERRAIN_H__)
#define __TERRAIN_H__

class Terrain{
   public:
       Terrain(int w, int h, double niveau = 3);
       ~Terrain();
       
       
       double&    eau(int x, int y) { return ep_eau[x+y*width]; }
       double&    sol(int x, int y) { return nivsol[x+y*width]; }
       double     total(int x, int y) { int i=x+y*width; return nivsol[i] + ep_eau[i];}
   
       int        getWidth() { return width;}
       int        getHeight() { return height;}
       float      getResolution() { return resolution;}
       
       void       getMinMax(double& min, double& max) const;
       
       void       lisser();
       
       void       approcherVoisin(int x, int y, double cible, double maxdiff);
       
       
       static Terrain* generateSinSin(int w, int h);
       static Terrain* generateRandom(int w, int h, int nbmont, int nblac);
       
   protected:
       double*  nivsol;  // niveau du sol
       double*  ep_eau;  // paisseur d'eau sur le sol
       int      width;
       int      height;
       
       float    resolution;

};



#endif

