/*
   Projet de simulation d'inondation.
   
   Version C++ utilisant QT et OpenGL.
   
   10 Avril 2004

   (C) Eric Beaudry & Universit de Sherbrooke 2004.
*/



#if !defined(__UTIL_H__)
#define __UTIL_H__

class Point;
class Vecteur;

class Point{
  public:
    Point(float x=0, float y=0, float z=0);
    
    Vecteur operator - (const Point& p) const;
  
    float   x,
            y,
	    z;
};

class Vecteur{
  public:
    Vecteur(float x=0, float y=0, float z=0);
    Vecteur(const Point& p1, const Point& p2);
    
    Vecteur& operator += (const Vecteur& autre);
    Vecteur  operator +  (const Vecteur& autre) const;
    
    Vecteur& operator *= (const float& scale);
    
    Vecteur  operator ^  (const Vecteur& autre) const;
    
    void     normalise();
    inline float    norme2();
    inline float    norme();
  
    float   x,
            y,
	    z;

	    
};


#endif
